# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from srcsim/Satellite.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Satellite(genpy.Message):
  _md5sum = "bad862aeda29f9dce04d39a915920fa2"
  _type = "srcsim/Satellite"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Target pitch angle in radians
float64 target_pitch

# Target yaw angle in radians
float64 target_yaw

# Current pitch angle in radians
float64 current_pitch

# Current yaw angle in radians
float64 current_yaw

# True if the current pitch angle is within a tolerance distance from the
# target pitch angle
bool pitch_correct_now

# True if the current yaw angle is within a tolerance distance from the
# target yaw angle
bool yaw_correct_now

# True if the pitch angle has been correct for enough time
bool pitch_completed

# True if the yaw angle has been correct for enough time
bool yaw_completed
"""
  __slots__ = ['target_pitch','target_yaw','current_pitch','current_yaw','pitch_correct_now','yaw_correct_now','pitch_completed','yaw_completed']
  _slot_types = ['float64','float64','float64','float64','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       target_pitch,target_yaw,current_pitch,current_yaw,pitch_correct_now,yaw_correct_now,pitch_completed,yaw_completed

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Satellite, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.target_pitch is None:
        self.target_pitch = 0.
      if self.target_yaw is None:
        self.target_yaw = 0.
      if self.current_pitch is None:
        self.current_pitch = 0.
      if self.current_yaw is None:
        self.current_yaw = 0.
      if self.pitch_correct_now is None:
        self.pitch_correct_now = False
      if self.yaw_correct_now is None:
        self.yaw_correct_now = False
      if self.pitch_completed is None:
        self.pitch_completed = False
      if self.yaw_completed is None:
        self.yaw_completed = False
    else:
      self.target_pitch = 0.
      self.target_yaw = 0.
      self.current_pitch = 0.
      self.current_yaw = 0.
      self.pitch_correct_now = False
      self.yaw_correct_now = False
      self.pitch_completed = False
      self.yaw_completed = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_4d4B.pack(_x.target_pitch, _x.target_yaw, _x.current_pitch, _x.current_yaw, _x.pitch_correct_now, _x.yaw_correct_now, _x.pitch_completed, _x.yaw_completed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.target_pitch, _x.target_yaw, _x.current_pitch, _x.current_yaw, _x.pitch_correct_now, _x.yaw_correct_now, _x.pitch_completed, _x.yaw_completed,) = _struct_4d4B.unpack(str[start:end])
      self.pitch_correct_now = bool(self.pitch_correct_now)
      self.yaw_correct_now = bool(self.yaw_correct_now)
      self.pitch_completed = bool(self.pitch_completed)
      self.yaw_completed = bool(self.yaw_completed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_4d4B.pack(_x.target_pitch, _x.target_yaw, _x.current_pitch, _x.current_yaw, _x.pitch_correct_now, _x.yaw_correct_now, _x.pitch_completed, _x.yaw_completed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.target_pitch, _x.target_yaw, _x.current_pitch, _x.current_yaw, _x.pitch_correct_now, _x.yaw_correct_now, _x.pitch_completed, _x.yaw_completed,) = _struct_4d4B.unpack(str[start:end])
      self.pitch_correct_now = bool(self.pitch_correct_now)
      self.yaw_correct_now = bool(self.yaw_correct_now)
      self.pitch_completed = bool(self.pitch_completed)
      self.yaw_completed = bool(self.yaw_completed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_4d4B = struct.Struct("<4d4B")
