# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from srcsim/Score.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class Score(genpy.Message):
  _md5sum = "7a5909e52bf9816c4b1e473aa285559b"
  _type = "srcsim/Score"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Array with the total time taken to complete each checkpoint across all tasks.
# The time is zero for skipped checkpoints or checkpoints which were never
# started due to task timeout.
duration[] checkpoint_durations

# Array with the total penalty time for each checkpoint across all tasks.
duration[] checkpoint_penalties

# The sum of the score across all checkpoints
uint8 score

# The sum of the time taken to complete all successful checkpoints, including
# the time penalties for those checkpoints.
# Incomplete checkpoints are not taken into account (neither the time spent
# trying, nor the penalties)
duration total_completion_time
"""
  __slots__ = ['checkpoint_durations','checkpoint_penalties','score','total_completion_time']
  _slot_types = ['duration[]','duration[]','uint8','duration']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       checkpoint_durations,checkpoint_penalties,score,total_completion_time

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Score, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.checkpoint_durations is None:
        self.checkpoint_durations = []
      if self.checkpoint_penalties is None:
        self.checkpoint_penalties = []
      if self.score is None:
        self.score = 0
      if self.total_completion_time is None:
        self.total_completion_time = genpy.Duration()
    else:
      self.checkpoint_durations = []
      self.checkpoint_penalties = []
      self.score = 0
      self.total_completion_time = genpy.Duration()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.checkpoint_durations)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_durations:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      length = len(self.checkpoint_penalties)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_penalties:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_B2i.pack(_x.score, _x.total_completion_time.secs, _x.total_completion_time.nsecs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.checkpoint_durations is None:
        self.checkpoint_durations = None
      if self.checkpoint_penalties is None:
        self.checkpoint_penalties = None
      if self.total_completion_time is None:
        self.total_completion_time = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_durations = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_durations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_penalties = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_penalties.append(val1)
      _x = self
      start = end
      end += 9
      (_x.score, _x.total_completion_time.secs, _x.total_completion_time.nsecs,) = _struct_B2i.unpack(str[start:end])
      self.total_completion_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.checkpoint_durations)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_durations:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      length = len(self.checkpoint_penalties)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_penalties:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_B2i.pack(_x.score, _x.total_completion_time.secs, _x.total_completion_time.nsecs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.checkpoint_durations is None:
        self.checkpoint_durations = None
      if self.checkpoint_penalties is None:
        self.checkpoint_penalties = None
      if self.total_completion_time is None:
        self.total_completion_time = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_durations = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_durations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_penalties = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_penalties.append(val1)
      _x = self
      start = end
      end += 9
      (_x.score, _x.total_completion_time.secs, _x.total_completion_time.nsecs,) = _struct_B2i.unpack(str[start:end])
      self.total_completion_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2i = struct.Struct("<2i")
_struct_B2i = struct.Struct("<B2i")
