# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from srcsim/Task.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class Task(genpy.Message):
  _md5sum = "233596f08c1743676d2ac74f80311110"
  _type = "srcsim/Task"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Task id
uint32 task

# Id of current checkpoint
uint32 current_checkpoint

# Array with the total time taken to complete each checkpoint. The time is zero
# for skipped checkpoints or checkpoints which were never started due to task
# timeout. This doesn't include penalties.
duration[] checkpoint_durations

# Array with the total penalty time for each checkpoint.
duration[] checkpoint_penalties

# Absolute sim time when this task started (ROS time)
time start_time

# Time elapsed since task started (ROS time). This is the current sim time
# minus start time, plus penalties for all checkpoints on this task.
# When the elapsed time reaches the task timeout, `timed_out` is set to true.
duration elapsed_time

# True if task timed out. This happens when the elapsed time plus the penalty
# time are larger than the timeout.
bool timed_out

# True if task has finished
bool finished
"""
  __slots__ = ['task','current_checkpoint','checkpoint_durations','checkpoint_penalties','start_time','elapsed_time','timed_out','finished']
  _slot_types = ['uint32','uint32','duration[]','duration[]','time','duration','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       task,current_checkpoint,checkpoint_durations,checkpoint_penalties,start_time,elapsed_time,timed_out,finished

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Task, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.task is None:
        self.task = 0
      if self.current_checkpoint is None:
        self.current_checkpoint = 0
      if self.checkpoint_durations is None:
        self.checkpoint_durations = []
      if self.checkpoint_penalties is None:
        self.checkpoint_penalties = []
      if self.start_time is None:
        self.start_time = genpy.Time()
      if self.elapsed_time is None:
        self.elapsed_time = genpy.Duration()
      if self.timed_out is None:
        self.timed_out = False
      if self.finished is None:
        self.finished = False
    else:
      self.task = 0
      self.current_checkpoint = 0
      self.checkpoint_durations = []
      self.checkpoint_penalties = []
      self.start_time = genpy.Time()
      self.elapsed_time = genpy.Duration()
      self.timed_out = False
      self.finished = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.task, _x.current_checkpoint))
      length = len(self.checkpoint_durations)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_durations:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      length = len(self.checkpoint_penalties)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_penalties:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_2I2i2B.pack(_x.start_time.secs, _x.start_time.nsecs, _x.elapsed_time.secs, _x.elapsed_time.nsecs, _x.timed_out, _x.finished))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.checkpoint_durations is None:
        self.checkpoint_durations = None
      if self.checkpoint_penalties is None:
        self.checkpoint_penalties = None
      if self.start_time is None:
        self.start_time = genpy.Time()
      if self.elapsed_time is None:
        self.elapsed_time = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.task, _x.current_checkpoint,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_durations = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_durations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_penalties = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_penalties.append(val1)
      _x = self
      start = end
      end += 18
      (_x.start_time.secs, _x.start_time.nsecs, _x.elapsed_time.secs, _x.elapsed_time.nsecs, _x.timed_out, _x.finished,) = _struct_2I2i2B.unpack(str[start:end])
      self.timed_out = bool(self.timed_out)
      self.finished = bool(self.finished)
      self.start_time.canon()
      self.elapsed_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.task, _x.current_checkpoint))
      length = len(self.checkpoint_durations)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_durations:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      length = len(self.checkpoint_penalties)
      buff.write(_struct_I.pack(length))
      for val1 in self.checkpoint_penalties:
        _x = val1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_2I2i2B.pack(_x.start_time.secs, _x.start_time.nsecs, _x.elapsed_time.secs, _x.elapsed_time.nsecs, _x.timed_out, _x.finished))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.checkpoint_durations is None:
        self.checkpoint_durations = None
      if self.checkpoint_penalties is None:
        self.checkpoint_penalties = None
      if self.start_time is None:
        self.start_time = genpy.Time()
      if self.elapsed_time is None:
        self.elapsed_time = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.task, _x.current_checkpoint,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_durations = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_durations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.checkpoint_penalties = []
      for i in range(0, length):
        val1 = genpy.Duration()
        _x = val1
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.checkpoint_penalties.append(val1)
      _x = self
      start = end
      end += 18
      (_x.start_time.secs, _x.start_time.nsecs, _x.elapsed_time.secs, _x.elapsed_time.nsecs, _x.timed_out, _x.finished,) = _struct_2I2i2B.unpack(str[start:end])
      self.timed_out = bool(self.timed_out)
      self.finished = bool(self.finished)
      self.start_time.canon()
      self.elapsed_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2I = struct.Struct("<2I")
_struct_2I2i2B = struct.Struct("<2I2i2B")
_struct_2i = struct.Struct("<2i")
